/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include <sys/types.h>
#include "mailfrom.h"
#include "prog.h"

#line 1 "bi_dns.m4"
/* This file is part of mailfrom filter.             -*- c -*-
   Copyright (C) 2006 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
   MA 02110-1301 USA */

#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>

void
#line 24
bi_hostname(eval_environ_t env)
#line 24 "bi_dns.m4"
{
#line 24
	char * string = (char *) get_arg(env, 0);
#line 24
        
#line 24
        adjust_stack(env, 1);
#line 24
	if (prog_trace_option)
#line 24
		prog_trace(env, "hostname %s",
#line 24
	                   string);
#line 24

{
	char *s = env_dict_getsym(env, string);
	if (!s) {
		char hbuf[NI_MAXHOST];
		if (resolve_ipstr(string, hbuf, sizeof(hbuf)))
			hbuf[0] = 0;
		s = env_dict_install(env, string, hbuf);
	}
	if (s[0] == 0)
		s = string;
	push(env, s);	
}
}

void
#line 39
bi_resolve(eval_environ_t env)
#line 39 "bi_dns.m4"
{
#line 39
	char * string = (char *) get_arg(env, 0);
#line 39
        
#line 39
        adjust_stack(env, 1);
#line 39
	if (prog_trace_option)
#line 39
		prog_trace(env, "resolve %s",
#line 39
	                   string);
#line 39

{
	char *s;
	struct hostent *host;
	
	s = env_dict_getsym(env, string);
	if (!s) {
		host = gethostbyname(string);
		if (!host)
			s = "0";
		else if (host->h_length == 4) {
			struct in_addr addr;
			addr.s_addr = *(unsigned long*)host->h_addr;
			s = inet_ntoa(addr);
		} else
			s = "resolved";
		s = env_dict_install(env, string, s);
	}
	push(env, s);	
}
}

void
#line 61
bi_hasmx(eval_environ_t env)
#line 61 "bi_dns.m4"
{
#line 61
	char * string = (char *) get_arg(env, 0);
#line 61
        
#line 61
        adjust_stack(env, 1);
#line 61
	if (prog_trace_option)
#line 61
		prog_trace(env, "hasmx %s",
#line 61
	                   string);
#line 61

{
	mxbuf_t mxbuf;
	mf_status mxstat;

	mxstat = getmx(string, mxbuf);
	
	if (mxstat != mf_success) {
		if (env_catch(env, mxstat) == 0)
			return;
	} else
		freemx(mxbuf);

	push(env, (STKVAL)(mxstat == mf_success));
}
}

static int
resolve_host(const char *string, unsigned long *ip)
{
	struct hostent *host = gethostbyname(string);
	if (!host)
		return 1;
	else if (host->h_length == 4) {
		*ip = *(unsigned long*)host->h_addr;
		return 0;
	}
	return 1;
}

void
#line 91
bi_ismx(eval_environ_t env)
#line 91 "bi_dns.m4"
{
#line 91
	char * domain = (char *) get_arg(env, 1);
#line 91
        char * ipstr = (char *) get_arg(env, 0);
#line 91
        
#line 91
        adjust_stack(env, 2);
#line 91
	if (prog_trace_option)
#line 91
		prog_trace(env, "ismx %s %s",
#line 91
	                   domain, ipstr);
#line 91

{
	mxbuf_t mxbuf;
	mf_status mxstat;
	unsigned long ip;
	int rc = 0;
	
	if (resolve_host(ipstr, &ip)) {
		if (env_catch(env, mf_resolve) == 0)
			return;
		runtime_error(env, "cannot resolve host name %s", ipstr);
	}
	
	mxstat = getmx(domain, mxbuf);
	
	if (mxstat != mf_success) {
		if (env_catch(env, mxstat) == 0)
			return;
	} else {
		int i;

		for (i = 0; i < MAXMXCOUNT && mxbuf[i]; i++) {
			unsigned long n;
			
			if (!resolve_host(mxbuf[i], &n) && n == ip) {
				rc = 1;
				break;
			}
		}
		freemx(mxbuf);
	}
	push(env, (STKVAL) rc);
}
}

void
#line 126
bi_relayed(eval_environ_t env)
#line 126 "bi_dns.m4"
{
#line 126
	char * s = (char *) get_arg(env, 0);
#line 126
        
#line 126
        adjust_stack(env, 1);
#line 126
	if (prog_trace_option)
#line 126
		prog_trace(env, "relayed %s",
#line 126
	                   s);
#line 126

{
	push(env, (STKVAL) relayed_domain_p(s));
}
}

void
#line 132
bi_listens(eval_environ_t env)
#line 132 "bi_dns.m4"
{
#line 132
	char * s = (char *) get_arg(env, 0);
#line 132
        
#line 132
        adjust_stack(env, 1);
#line 132
	if (prog_trace_option)
#line 132
		prog_trace(env, "listens %s",
#line 132
	                   s);
#line 132

{
	push(env, (STKVAL)(listens_on (s, 25) == mf_success));
}
}

void
#line 138
bi_match_cidr(eval_environ_t env)
#line 138 "bi_dns.m4"
{
#line 138
	char * ipstr = (char *) get_arg(env, 1);
#line 138
        char * cidrstr = (char *) get_arg(env, 0);
#line 138
        
#line 138
        adjust_stack(env, 2);
#line 138
	if (prog_trace_option)
#line 138
		prog_trace(env, "match_cidr %s %s",
#line 138
	                   ipstr, cidrstr);
#line 138

{
	char *p;
	struct in_addr addr, cidr;
	char netbuf[16], *netstr;
	unsigned long netmask;
	int result = 0;
	const struct locus *locus = env_get_locus(env);
	
	do {
		if (inet_aton(ipstr, &addr) == 0) {
			if (env_catch(env, mf_invip) == 0)
				return;
			runtime_error(env, "invalid IP address (%s)",
				      ipstr);
		}
		p = strchr(cidrstr, '/');
		if (!p) {
			netstr = cidrstr;
			netmask = 0xfffffffful;
		} else {
			size_t len = p - cidrstr;
			unsigned long n;
			
			if (len >= sizeof netbuf) {
				if (env_catch(env, mf_invcidr) == 0)
					return;
				runtime_error(env, "invalid CIDR (%s)",
					      cidrstr);
			} 
			memcpy(netbuf, cidrstr, len);
			netbuf[len] = 0;
			netstr = netbuf;
			n = strtoul(p + 1, &p, 10);
			if (*p || n > 32) {
				if (env_catch(env, mf_invcidr) == 0)
					return;
				runtime_error(env,
					      "invalid CIDR (netmask of %s)",
					      cidrstr);
			}
			n = 32 - n;
			if (n == 32)
				netmask = 0;
			else
				netmask = (0xfffffffful >> n) << n;
		}
		if (inet_aton(netstr, &cidr) == 0) {
			if (env_catch(env, mf_invcidr) == 0)
				return;
			runtime_warning(env,
					"invalid CIDR (network part of %s)",
					cidrstr);
			break;
		}

		addr.s_addr = ntohl(addr.s_addr);
		cidr.s_addr = ntohl(cidr.s_addr);
		debug5(100, "%s:%lu: addr=%lx net=%lx mask=%lx" ,
		       locus->file, locus->line,
		       addr.s_addr, cidr.s_addr, netmask);
		result = (addr.s_addr & netmask) == cidr.s_addr;
	} while (0);
	push(env, (STKVAL) result);
}
}

void
#line 205
bi_domainpart(eval_environ_t env)
#line 205 "bi_dns.m4"
{
#line 205
	char * str = (char *) get_arg(env, 0);
#line 205
        
#line 205
        adjust_stack(env, 1);
#line 205
	if (prog_trace_option)
#line 205
		prog_trace(env, "domainpart %s",
#line 205
	                   str);
#line 205

{
	char *p = strchr(str, '@');
	pushs(env, p ? p+1 : str);
}
}

void
#line 212
bi_localpart(eval_environ_t env)
#line 212 "bi_dns.m4"
{
#line 212
	char * str = (char *) get_arg(env, 0);
#line 212
        
#line 212
        adjust_stack(env, 1);
#line 212
	if (prog_trace_option)
#line 212
		prog_trace(env, "localpart %s",
#line 212
	                   str);
#line 212

{
	char *p = strchr(str, '@');

	if (p) {
		size_t size = p - str;
		char *string_space = heap_reserve(env, size);
		memcpy(string_space, str, size);
		string_space[size] = 0;
		push(env, string_space);
	} else
		pushs(env, str);
}
}


#line 227
void
#line 227
dns_init_builtin()
#line 227
{
#line 227
	#line 24 "bi_dns.m4"
va_builtin_install_ex("hostname", bi_hostname, 0, 0, rettype_string, 1, rettype_string);
#line 39 "bi_dns.m4"
va_builtin_install_ex("resolve", bi_resolve, 0, 0, rettype_string, 1, rettype_string);
#line 61 "bi_dns.m4"
va_builtin_install_ex("hasmx", bi_hasmx, 0, 0, rettype_number, 1, rettype_string);
#line 91 "bi_dns.m4"
va_builtin_install_ex("ismx", bi_ismx, 0, 0, rettype_number, 2, rettype_string, rettype_string);
#line 126 "bi_dns.m4"
va_builtin_install_ex("relayed", bi_relayed, 0, 0, rettype_number, 1, rettype_string);
#line 132 "bi_dns.m4"
va_builtin_install_ex("listens", bi_listens, 0, 0, rettype_number, 1, rettype_string);
#line 138 "bi_dns.m4"
va_builtin_install_ex("match_cidr", bi_match_cidr, 0, 0, rettype_number, 2, rettype_string, rettype_string);
#line 205 "bi_dns.m4"
va_builtin_install_ex("domainpart", bi_domainpart, 0, 0, rettype_string, 1, rettype_string);
#line 212 "bi_dns.m4"
va_builtin_install_ex("localpart", bi_localpart, 0, 0, rettype_string, 1, rettype_string);

#line 227 "bi_dns.m4"
		
#line 227
}
#line 0

#line 0

